



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ 3527: [Zjoi2014]力</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ 3527: [Zjoi2014]力</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:35:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Description</h2>
<p>求 \(E_i=\sum _{j=0}^{i-1} \frac {q_j} {(i-j)^2}-\sum _{j=i+1}^{n-1} \frac{q_j} {(i-j)^2}\)</p>
<h2>Sol</h2>
<p>FFT.</p>
<p>我们可以发现他是一个卷积的形式,每次从\(i^2\) 卷到 \((n-i-1)^2\) .</p>
<p>既然是卷积,那么直接FFT就好了,但是FFT是让指数相等,也就是这里面的下标相等,所以必须要翻转这两个数组其中一个就可以了,随便翻就行.</p>
<p>然后从某一个下下标位置开始输出.</p>
<h2>Code</h2>
<div>
<pre class="prettyprint linenums">/**************************************************************<br />
    Problem: 3527<br />
    User: BeiYu<br />
    Language: C++<br />
    Result: Accepted<br />
    Time:2696 ms<br />
    Memory:24732 kb<br />
****************************************************************/

#include &lt;bits/stdc++.h&gt;<br />
using namespace std;

#define mpr make_pair<br />
#define rr first<br />
#define ii second<br />
const int N = 5e5+50;<br />
const double Pi = M_PI;<br />
typedef pair&lt; double,double &gt; Complex;

Complex operator + (const Complex &amp;a,const Complex &amp;b) {<br />
    return mpr(a.rr+b.rr,a.ii+b.ii);<br />
}<br />
Complex operator - (const Complex &amp;a,const Complex &amp;b) {<br />
    return mpr(a.rr-b.rr,a.ii-b.ii);<br />
}<br />
Complex operator * (const Complex &amp;a,const Complex &amp;b) {<br />
    return mpr(a.rr*b.rr-a.ii*b.ii,a.rr*b.ii+a.ii*b.rr);<br />
}

int n,m;<br />
Complex a[N],b[N],c[N];

void init(int x) {<br />
    for(n=1,m=0;n&lt;x;n&lt;&lt;=1,m++);<br />
    m++,n&lt;&lt;=1;<br />
}<br />
void Rev(Complex a[]) {<br />
    for(int i=0,j=0,k;i&lt;n;i++) {<br />
        if(i&gt;j) swap(a[i],a[j]);<br />
        for(k=n&gt;&gt;1;(j^=k)&lt;k;k&gt;&gt;=1);<br />
    }<br />
}<br />
void DFT(Complex y[],int r) {<br />
    Rev(y);<br />
    for(int i=2;i&lt;=n;i&lt;&lt;=1) {<br />
        Complex wi=mpr(cos(2.0*Pi/i),r*sin(2.0*Pi/i));<br />
        for(int k=0;k&lt;n;k+=i) {<br />
            Complex w=mpr(1.0,0.0);<br />
            for(int j=k;j&lt;k+i/2;j++) {<br />
                Complex t1=y[j],t2=w*y[j+i/2];<br />
                y[j]=t1+t2,y[j+i/2]=t1-t2;<br />
                w=w*wi;<br />
            }<br />
        }<br />
    }if(r==-1) for(int i=0;i&lt;n;i++) y[i].rr/=n;<br />
}<br />
void FFT(Complex a[],Complex b[],Complex c[]) {<br />
    DFT(a,1);DFT(b,1);<br />
    for(int i=0;i&lt;n;i++) c[i]=a[i]*b[i];<br />
    DFT(c,-1);<br />
}<br />
int main() {<br />
//  freopen("in.in","r",stdin);<br />
    int l;<br />
    scanf("%d",&amp;l);<br />
    for(int i=0;i&lt;l;i++) scanf("%lf",&amp;a[i].rr);<br />
    for(int i=0;i&lt;l-1;i++) {<br />
        b[i]=mpr(1.0/(l-i-1.0)/(l-i-1.0),0.0);<br />
        b[2*l-1-i-1]=mpr(-1.0/(l-i-1.0)/(l-i-1.0),0.0);<br />
    }<br />
    init(l);<br />
//  for(int i=0;i&lt;n;i++) cout&lt;&lt;b[i].rr&lt;&lt;" ";cout&lt;&lt;endl;<br />
//  for(int i=0;i&lt;n;i++) cout&lt;&lt;a[i].rr&lt;&lt;" ";cout&lt;&lt;endl;<br />
//  reverse(a,a+l);<br />
    reverse(b,b+2*l-1);<br />
//  reverse(b,b+n);<br />
//  for(int i=0;i&lt;n;i++) cout&lt;&lt;b[i].rr&lt;&lt;" ";cout&lt;&lt;endl;<br />
//  for(int i=0;i&lt;n;i++) cout&lt;&lt;a[i].rr&lt;&lt;" ";cout&lt;&lt;endl;<br />
    FFT(a,b,c);<br />
//  for(int i=0;i&lt;n;i++) printf("%lf\n",c[i].rr);<br />
    for(int i=l-1;i&lt;2*l-1;i++) printf("%lf\n",c[i].rr);<br />
    return 0;<br />
}<br />
/*<br />
5<br />
4006373.885184<br />
15375036.435759<br />
1717456.469144<br />
8514941.004912<br />
1410681.345880<br />
*/
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390d4j48.html">Palindrome Number</a>
		</li>
						<li><a href="https://www.batexi.com/a/495voo0q.html">Debian Vi&nbsp;简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k735j9.html">TFS&lpar;Team Foundation Server&rpar;敏捷使用教程&lpar;四&rpar;：工作项跟踪（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/3906p4j9.html">【GPU编解码】GPU硬编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o7ompq.html">MVC学习笔记---MVC的处理管线</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xjjkz9.html">mysql死锁，等待资源，事务锁，Lock wait timeout exceeded&semi; try restarting transaction解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1j5rd9.html">Laravel 5 基础（一）- Laravel入门和新建项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mgxnkq.html">每日一&OpenCurlyDoubleQuote;酷&rdquo;之Queue</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmxjnz9.html">dos常用文件操作命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdevrzj9.html">Windows 下OpenSSL 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m6dx1q.html">RabbitMQ中文入门教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kjpr69.html">Scalatra--Introduction And Quick start</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljk3o09.html">jQuery链式操作如何返回上一级DOM</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gex4kl8.html">介绍一个法国的时间戳server</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd5d1d9.html">&lbrack;APIO2012&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90reor39.html">Spark中groupByKey、reduceByKey与sortByKey</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlwlnz9.html">（KMP）Simpsons&rsquo; Hidden Talents -- hdu -- 2594</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em6rwz9.html">一、Open CV3&period;0&period;0 与 VS2012配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k4vkxq.html">11GR2 中的常见 RMAN 问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4zwlxq.html">批量删除&period;svn文件夹和&period;svn文件</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8z16k19.html">&lbrack;LeetCode&rsqb; Ones and Zeroes 一和零</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdexpz9.html">CSS优先级</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1zd709.html">&period;net core 源码解析-web app是如何启动并接收处理请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvvneyq.html">css3-无缝滚动</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pjydk9.html">echarts-在现实标题中显示百分比</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1zoo69.html">关于repaint&lpar;重绘&rpar;和reflow&lpar; 回流&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gmywz9.html">linux 下shell中if的&OpenCurlyDoubleQuote;-e，-d，-f&rdquo;是什么意思</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7mylkq.html">Codeforces Round &num;384 &lpar;Div&period; 2&rpar; B&period; Chloe and the sequence（规律题）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2wzk3q.html">sublime的插件安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvvlgzq.html">机器学习&mdash;&mdash;k-近邻算法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
